# nbOfCages.py
# calculate the number of cages 
# for a Hagelin cipher machine without overlaps i.e 
# with one lug by bar

import sys
import getopt

def isGoodKey(t):
  table = [0]*26
  for u in range(2):
    for v in range(2):
      for w in range(2):
        for x in range(2):
          for y in range(2):
            for z in range(2):
              somme = u*t[0] + v*t[1] + w*t[2] + x*t[3] + y*t[4] + z*t[5]
              table[somme%26]=1
  for i in range(26):
    if table[i] == 0 :return 0
  return 1

def isAllWheelsAct(t):
    for i in range(len(t)):
        if t[i] == 0: return False
    return True

def usage():
    print "Usage: ", sys.argv[0], " [options]"
    print "-h       Help"
    print "-p       Permuted (not ordered)"

#----------- Start of program -----------
try:
    opts, args = getopt.getopt(sys.argv[1:],"hdp",
    ["help","debug","permuted"])
except getopt.GetoptError as err:
    print sys.argv[0],": ", str(err)
    usage()
    sys.exit(2)

N=27            # Number of bars (and number of lugs)
count=0         # Total number of cages (ordered or not ordered)
good=0          # Total number of good cages (ordered or not ordered)
nempty=0        # Total number of cages without 0 lugs front of a wheel
neng=0          # Cages no empty no good
ORDER = True    # Boolean which indicates if the cages are ordered (or not)

for o, a in opts:
    if o in ("-h", "--help"):
        usage()
        sys.exit()
    elif o in ("-d", "--debug"):
        DEBUG = True
    elif o in ("-p", "--permuted"):
        ORDER = False

# --- start of the big loop
for i in range(N+1):
 for j in range(N+1):
  for k in range(N+1):
   for l in range(N+1):
    for m in range(N+1):
     for n in range(N+1):
        T=i+j+k+l+m+n
        if T != N: continue
        tb = [i,j,k,l,m,n]
        if ORDER:
            if not (i<=j and j<=k and k<=l and l<=m and m<=n):
                continue
        count +=1
        print "%3d:[%2d %2d %2d %2d %2d %2d]" % (count,i,j,k,l,m,n),
        if isGoodKey(tb):
            print "*", ; good += 1
            if isAllWheelsAct(tb):
                print "=" ; nempty += 1
            else:
                print 
        else:
            if isAllWheelsAct(tb):
                print "$", ; neng += 1
            print
           
print "Total number of cages ",
if ORDER: print "(ordered)",
else: print "(not ordered [then permuted])",
print ": ", count
print "Cages with no wheels without zero lug front (=|$)   : ", nempty+neng
print "Good cages (*)                                      : ", good
print "Good cages with no wheels without zero lug front (=): ", nempty


